#include "bla.h"
#include <time.h>

typedef unsigned char UC;

#define bla_TABLESIZ	16

static HWND bla_table_hw[bla_TABLESIZ];
static bla_Window *bla_table_w[bla_TABLESIZ];

LRESULT CALLBACK WndProc(HWND hw, unsigned int msg, WPARAM wp, LPARAM lp);

static int winthread(bla_Window *w)
{
	WNDCLASSEX wc;
	RECT r;
	int i, x, y;
	MSG msg;

	x = w->xsiz;
	y = w->ysiz;

	wc.cbSize = sizeof (WNDCLASSEX);
	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = WndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = w->hInst;
	wc.hIcon = (HICON) LoadImage(NULL, MAKEINTRESOURCE(IDI_APPLICATION),
		IMAGE_ICON, 0, 0, LR_DEFAULTSIZE | LR_SHARED);
	wc.hIconSm = wc.hIcon;
	wc.hCursor = (HCURSOR)LoadImage(NULL, MAKEINTRESOURCE(IDC_ARROW),
		IMAGE_CURSOR, 0, 0, LR_DEFAULTSIZE | LR_SHARED);
	wc.hbrBackground = (HBRUSH) COLOR_APPWORKSPACE;
	wc.lpszMenuName = NULL;
	wc.lpszClassName = w->winTitle;
	if (RegisterClassEx(&wc) == 0)
		return 1;
	r.left = 0;
	r.top = 0;
	r.right = x;
	r.bottom = y;
	AdjustWindowRect(&r, WS_OVERLAPPEDWINDOW, FALSE);
	x = r.right - r.left;
	y = r.bottom - r.top;

	w->hWnd = CreateWindowA(wc.lpszClassName, w->winTitle, WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT, CW_USEDEFAULT, x, y, NULL, NULL,	w->hInst, NULL);
	if (w->hWnd == NULL)
		return 1;
	bla_table_hw[w->table_idx] = w->hWnd;
	ShowWindow(w->hWnd, SW_SHOW);
	UpdateWindow(w->hWnd);

	for (;;) {
		i = GetMessage(&msg, NULL, 0, 0);
		if (i == 0 || i == -1)	/* G[͏IbZ[W */
			break;
		/* ̂ق͂Ƃ肠ftHg */
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	w->phase = 0;
	free(w->buf);
	UnregisterClass(w->winTitle, w->hInst);
	return 0;
}

LRESULT CALLBACK WndProc(HWND hw, unsigned int msg, WPARAM wp, LPARAM lp)
{
	bla_Window *w;
	int i, j;
	for (i = 0; i < bla_TABLESIZ; i++) {
		if (bla_table_hw[i] == hw)
			break;
	}
	if (i >= bla_TABLESIZ)
		return DefWindowProc(hw, msg, wp, lp);
	w = bla_table_w[i];
	if (msg == WM_PAINT) {
		PAINTSTRUCT ps;
		HDC hdc = BeginPaint(hw, &ps);
		SetDIBitsToDevice(hdc, 0, 0, w->xsiz, w->ysiz,
			0, 0, 0, w->ysiz, w->buf, &w->bmi, DIB_RGB_COLORS);
		EndPaint(hw, &ps);
		return 0;
	}
	if (msg == WM_DESTROY) {
		PostQuitMessage(0); // ȂƃXbhIȂ.
		return 0;
	}
#if 0
	if (msg == WM_KEYDOWN || msg == WM_SYSKEYDOWN) {
		i = -1;
#if 0
		int s_sht = GetKeyState(VK_SHIFT);
		int s_ctl = GetKeyState(VK_CONTROL);
		int s_cap = GetKeyState(VK_CAPITAL);
		int s_num = GetKeyState(VK_NUMLOCK);
		if ('A' <= wp && wp <= 'Z') {
			i = wp;
			if (((s_sht < 0) ^ (s_cap & 1)) == 0)
				i += 'a' - 'A';
		}
		if (wp == VK_SPACE)		i = ' ';
#endif
		if (wp == VK_RETURN)	i = KEY_ENTER;
		if (wp == VK_ESCAPE)	i = KEY_ESC;
		if (wp == VK_BACK)		i = KEY_BACKSPACE;
		if (wp == VK_TAB)		i = KEY_TAB;
		if (wp == VK_PRIOR)		i = KEY_PAGEUP;
		if (wp == VK_NEXT)		i = KEY_PAGEDWN;
		if (wp == VK_END)		i = KEY_END;
		if (wp == VK_HOME)		i = KEY_HOME;
		if (wp == VK_LEFT)		i = KEY_LEFT;
		if (wp == VK_RIGHT)		i = KEY_RIGHT;
		if (wp == VK_UP)		i = KEY_UP;
		if (wp == VK_DOWN)		i = KEY_DOWN;
		if (wp == VK_INSERT)	i = KEY_INS;
		if (wp == VK_DELETE)	i = KEY_DEL;
		if (((j = WndProcSub()) & 0x06060000) != 0 && 'A' <= wp && wp <= 'Z')
			i = wp;
		if (i != -1) {
			putKeybuf(i | j, pwtp);
			return 0;
		}
	}
//	if (msg == WM_KEYUP) { i = 0xfff; }
	if (msg == WM_CHAR) {
		if (' ' <= wp && wp <= 0x7e) {
			if (('A' <= wp && wp <= 'Z') || ('a' <= wp && wp <= 'z')) {
				if (((j = WndProcSub()) & 0x06060000) != 0 != 0)
					wp = (wp | j) & ~0x20; // 啶.
			}
			putKeybuf(wp, pwtp);
			return 0;
		}
	}
#endif
	return DefWindowProc(hw, msg, wp, lp);
}

bla_Window *bla_openWin(int x, int y, const char *t)
{
	int i, j;
	for (i = 0; i < bla_TABLESIZ; i++) {
		if (bla_table_hw[i] == 0) break;
	}
	if (i >= bla_TABLESIZ) return 0;
	bla_table_hw[i] = (HWND) 1;

	bla_Window *w = malloc(sizeof (bla_Window));
	bla_table_w[i] = w;
	w->table_idx = i;
	strncpy(w->winTitle, t, 31);
	w->winTitle[31] = '\0';

	w->phase = 1;
	w->xsiz = x;
	w->ysiz = y;
	w->buf = malloc(x * y * sizeof (int));
	w->lastFlush = (int) clock();
#if 0
	w->cx = pwtp->cy = 0;
	w->col = 0xffffff;
	w->bcol = 0;
	w->kbf = KEYBUFSIZ;
	w->kbpr = 0;
	w->kbpw = 0;
	w->gets_ph = 0;
#endif
	for (j = 0; j < y; j++) {
		for (i = 0; i < x; i++)
			w->buf[j * x + i] = 0;
	}
	w->bmi.bmiHeader.biSize = sizeof (BITMAPINFOHEADER);
	w->bmi.bmiHeader.biWidth = x;
	w->bmi.bmiHeader.biHeight = - y;
	w->bmi.bmiHeader.biPlanes = 1;
	w->bmi.bmiHeader.biBitCount = 32;
	w->bmi.bmiHeader.biCompression = BI_RGB;
	CreateThread(NULL, 0, (void *) &winthread, (void *) w, 0, (void *) &i);
	return w;
}

void bla_flushAll(bla_Window *w)
{
	if (w->phase == 1) {
		InvalidateRect(w->hWnd, NULL, FALSE);
		UpdateWindow(w->hWnd);
		w->lastFlush = (int) clock();
	}
	return;
}

void bla_leapFlushAll(bla_Window *w, unsigned int t)
{
	if (t == 0 || (unsigned int) (((int) clock()) - w->lastFlush) >= t)
		bla_flushAll(w);
	return;
}

void bla_wait(int msec)
{
	if (msec != -1)
		Sleep(msec);
	else {
		for (;;)
			Sleep(10000);
	}
	return;
}

void bla_closeWin(bla_Window *w)
{
	if (w->phase == 1)
		PostMessage(w->hWnd, WM_CLOSE, 0, 0);
	return;
}

void bla_exit() { return; }

