#include <windows.h>

typedef struct bla_Window_ {
	unsigned char winTitle[32];
	HWND hWnd;
	HINSTANCE hInst;
	BITMAPINFO bmi;
	int xsiz, ysiz, *buf, table_idx, lastFlush;
	unsigned char phase;
} bla_Window;

bla_Window *bla_openWin(int xsiz, int ysiz, const char *title);
void bla_flushAll(bla_Window *w);
void bla_leapFlushAll(bla_Window *w, unsigned int t);
void bla_wait(int msec);
void bla_exit();

inline static int bla_rgb(int r, int g, int b) { return r << 16 | g << 8 | b; }
inline static void bla_setPix(bla_Window *w, int x, int y, int c) { w->buf[y * w->xsiz + x] = c; }

